﻿package 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import com.citrusengine.core.CitrusEngine;
	import com.citrusengine.core.State;
	import com.citrusengine.physics.Box2D;
	import com.citrusengine.objects.platformer.*;
	import com.citrusengine.objects.*;
	import com.citrusengine.math.MathVector;
	import flash.events.Event;
	import flash.geom.Rectangle;
	import flash.ui.Keyboard;
	import flash.events.KeyboardEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import com.greensock.TweenNano;
	import com.greensock.easing.Expo;
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import flash.filters.GlowFilter;
	import flash.filters.BitmapFilter;
	
	public final class Level extends State
	{
		private var levelView:LevelView = new LevelView();
		private var hero:Hero;
		private var hearts:Vector.<Sprite> = new Vector.<Sprite>();
		private var tf:TextFormat = new TextFormat('ArcadeClassic', 17, 0xFFFFFF, null, null, null, null, null, 'right');
		private var scoreTF:TextField = new TextField();
		private var gemSnd:GemSnd = new GemSnd();
		private var goalSnd:GoalSnd = new GoalSnd();
		private var hitSnd:HitSnd = new HitSnd();
		private var jumpSnd:JumpSnd = new JumpSnd();
		private var loseSnd:LoseSnd = new LoseSnd();
		private var baddySnd:BaddySnd = new BaddySnd();
		
		public final function Level():void
		{
			super();
			CitrusEngine.getInstance().playing = false;
		}
		override public function initialize():void
		{
			/* Level Start View */
			
			addChild(levelView);
			levelView.addEventListener(MouseEvent.MOUSE_UP, startLevel);
		}
		
		private final function startLevel(e:MouseEvent):void
		{
			levelView.removeEventListener(MouseEvent.MOUSE_UP, startLevel);
			removeChild(levelView);
			levelView = null;
			
			super.initialize();
			CitrusEngine.getInstance().playing = true;
			
			var box2D:Box2D = new Box2D('Box2d');
			add(box2D);
			//box2D.visible = true;
			
			var leftWall:Platform = new Platform('LeftWall', {width:1, height:280, x:0, y:110});
			add(leftWall);
			
			var rightWall:Platform = new Platform('RightWall', {width:1, height:280, x:726, y:100});
			add(rightWall);

			var bg:CitrusSprite = new CitrusSprite('Bg', {view:Bg, x:0, y:20});
			add(bg);

			var terrain1:Platform = new Platform('Terrain1', {width:422, height:32, x: 211, y:264, view:TerrainPart1});
			add(terrain1);
			
			var oneWay1:Platform = new Platform('OneWay1', {width:92, height:32, x:184, y:232, oneWay:true, view:OneWay1});
			add(oneWay1);
			
			var gem:Coin = new Coin('Gem',{width:11, height:10, x:186, y:136, view:Gem});
			add(gem);
			
			var water:Sensor = new Sensor('Water', {width:92, height:32, x: 468, y:264, view:WaterX3});
			add(water);
			
			var terrain2:Platform = new Platform('Terrain2', {width:214, height:32, x:621, y:264, view:TerrainPart2});
			add(terrain2);

			var baddy:Baddy = new Baddy('Baddy', {x:300, y:200, leftBound:250, rightBound:350, view:Enemy});
			add(baddy);
			
			var movingPlatform:MovingPlatform = new MovingPlatform('MP',{width:32, height:8, x:436, y:232, startX:436, startY:232, endX:500, endY:232, view:PlatformClip, speed:0.9});
			add(movingPlatform);
			
			var oneWay2:Platform = new Platform('OneWay2', {width:127, height:32, x:663, y:232, oneWay:true, view:OneWay2});
			add(oneWay2);
			
			var oneWay3:Platform = new Platform('OneWay3', {width:64, height:32, x:695, y:200, oneWay:true, view:OneWay3});
			add(oneWay3);
			
			var door:Sensor = new Sensor('Door', {width:20, height:28, x:695, y:202, view:Door});
			add(door);
			
			hero = new Hero('Hero', {x:30, y:234, width:19, height:26, view:HeroClip, jumpHeight:9, maxVelocity:2, hurtVelocityX:2});
			add(hero);
			
			gem.onBeginContact.addOnce(function(e:*){gemSnd.play();scoreTF.text = String(int(scoreTF.text) + 50);});
			door.onBeginContact.addOnce(levelComplete);
			
			hero.onTakeDamage.add(hurtHero);
			hero.onGiveDamage.addOnce(killBaddy);
			hero.onJump.add(function(){jumpSnd.play()});
			hero.onGiveDamage.addOnce(function(){baddySnd.play()});
			
			this.view.getArt(hero).content.stop(); //State(Level).SpriteView.SpriteArt.MovieClip.stop
			
			gameListeners();
			addIndicators();
		}
		
		private final function gameListeners(action:String = 'add'):void
		{
			if(action == 'add')
			{
				stage.addEventListener(Event.ENTER_FRAME, gameLogic);
				stage.addEventListener(KeyboardEvent.KEY_DOWN, animateWalk);
				stage.addEventListener(KeyboardEvent.KEY_UP, stopWalk);
			}
			else
			{
				stage.removeEventListener(Event.ENTER_FRAME, gameLogic);
				stage.removeEventListener(KeyboardEvent.KEY_DOWN, animateWalk);
				stage.removeEventListener(KeyboardEvent.KEY_UP, stopWalk);
			}
		}
		
		private final function addIndicators():void
		{
			/* Hearts */
			
			for(var i:int = 0; i < 3; i++)
			{
				var heart:Heart = new Heart();
				heart.y = 5;
				heart.x = 5 + (i * heart.width);
				addChild(heart);
				hearts.push(heart);
			}
			
			/* Score */
			
			scoreTF.x = 320;
			scoreTF.defaultTextFormat = tf;
			scoreTF.text = '0';
			var filter:BitmapFilter = new GlowFilter(0, 1, 2, 2);
			var filter2:BitmapFilter = new GlowFilter(0, 1, 1, 1);
			scoreTF.filters = [filter, filter2];
			addChild(scoreTF);
		}
		
		private final function gameLogic(e:Event):void
		{
			/* Handle Camera */
			
			if(hero.x >= stage.stageWidth * 0.5)
			{
				view.setupCamera(hero, new MathVector(stage.stageWidth * 0.5, 234), new Rectangle(0, 0, 726, 228), null);
			}
			
			/* Check if hero fell */
			
			if(hero.y > stage.stageHeight)
			{
				loseSnd.play();
				alert('lose');
			}
		}
		
		private final function animateWalk(e:KeyboardEvent):void
		{
			if(e.keyCode == 37 || e.keyCode == 39)
			{
				this.view.getArt(hero).content.play();
			}
		}
		
		private final function stopWalk(e:KeyboardEvent):void
		{
			if(e.keyCode == 37 || e.keyCode == 39)
			{
				this.view.getArt(hero).content.gotoAndStop(1);
			}
		}
		
		private final function hurtHero():void
		{
			removeChild(hearts[hearts.length-1]);
			hearts.splice(hearts.length-1, 1);
			
			hitSnd.play();
			
			if(hearts.length <= 0)
			{
				loseSnd.play();
				alert('lose');
			}
		}
		
		private final function killBaddy():void
		{
			scoreTF.text = String(int(scoreTF.text) + 100);
		}
		
		private final function levelComplete(e:*):void
		{
			goalSnd.play();
			alert();
		}
		
		private final function alert(gameState:String = 'win'):void
		{
			gameListeners('rmv');
			CitrusEngine.getInstance().playing = false;
			this.view.getArt(hero).content.gotoAndStop(1);
			
			var alert:AlertView = new AlertView();
			
			alert.x = stage.stageWidth * 0.5;
			alert.y = stage.stageHeight * 0.5;
			alert.scoreTF.text = scoreTF.text;
			alert.addEventListener(MouseEvent.MOUSE_UP, restart);
			
			if(gameState == 'lose')
			{
				alert.titleTF.text = 'Level Failed!';
			}
			
			addChild(alert);
			TweenNano.from(alert, 0.6, {scaleX: 0.2, scaleY: 0.2, ease:Expo.easeOut});
		}
		
		private final function restart(e:MouseEvent):void
		{
			navigateToURL(new URLRequest(stage.loaderInfo.url), '_level0');
		}
	}
}